package com.chinaitop.depot.intelligent.grainsituation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TTestdataExample {
    /**
     * t_testdata
     */
    protected String orderByClause;

    /**
     * t_testdata
     */
    protected boolean distinct;

    /**
     * t_testdata
     */
    protected List<Criteria> oredCriteria;

    public TTestdataExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_testdata 2019-07-23
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andStorehouseIsNull() {
            addCriterion("storehouse is null");
            return (Criteria) this;
        }

        public Criteria andStorehouseIsNotNull() {
            addCriterion("storehouse is not null");
            return (Criteria) this;
        }

        public Criteria andStorehouseEqualTo(String value) {
            addCriterion("storehouse =", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseNotEqualTo(String value) {
            addCriterion("storehouse <>", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseGreaterThan(String value) {
            addCriterion("storehouse >", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseGreaterThanOrEqualTo(String value) {
            addCriterion("storehouse >=", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseLessThan(String value) {
            addCriterion("storehouse <", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseLessThanOrEqualTo(String value) {
            addCriterion("storehouse <=", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseLike(String value) {
            addCriterion("storehouse like", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseNotLike(String value) {
            addCriterion("storehouse not like", value, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseIn(List<String> values) {
            addCriterion("storehouse in", values, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseNotIn(List<String> values) {
            addCriterion("storehouse not in", values, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseBetween(String value1, String value2) {
            addCriterion("storehouse between", value1, value2, "storehouse");
            return (Criteria) this;
        }

        public Criteria andStorehouseNotBetween(String value1, String value2) {
            addCriterion("storehouse not between", value1, value2, "storehouse");
            return (Criteria) this;
        }

        public Criteria andHouseIsNull() {
            addCriterion("house is null");
            return (Criteria) this;
        }

        public Criteria andHouseIsNotNull() {
            addCriterion("house is not null");
            return (Criteria) this;
        }

        public Criteria andHouseEqualTo(String value) {
            addCriterion("house =", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseNotEqualTo(String value) {
            addCriterion("house <>", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseGreaterThan(String value) {
            addCriterion("house >", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseGreaterThanOrEqualTo(String value) {
            addCriterion("house >=", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseLessThan(String value) {
            addCriterion("house <", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseLessThanOrEqualTo(String value) {
            addCriterion("house <=", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseLike(String value) {
            addCriterion("house like", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseNotLike(String value) {
            addCriterion("house not like", value, "house");
            return (Criteria) this;
        }

        public Criteria andHouseIn(List<String> values) {
            addCriterion("house in", values, "house");
            return (Criteria) this;
        }

        public Criteria andHouseNotIn(List<String> values) {
            addCriterion("house not in", values, "house");
            return (Criteria) this;
        }

        public Criteria andHouseBetween(String value1, String value2) {
            addCriterion("house between", value1, value2, "house");
            return (Criteria) this;
        }

        public Criteria andHouseNotBetween(String value1, String value2) {
            addCriterion("house not between", value1, value2, "house");
            return (Criteria) this;
        }

        public Criteria andTimeIsNull() {
            addCriterion("time is null");
            return (Criteria) this;
        }

        public Criteria andTimeIsNotNull() {
            addCriterion("time is not null");
            return (Criteria) this;
        }

        public Criteria andTimeEqualTo(Date value) {
            addCriterion("time =", value, "time");
            return (Criteria) this;
        }

        public Criteria andTimeNotEqualTo(Date value) {
            addCriterion("time <>", value, "time");
            return (Criteria) this;
        }

        public Criteria andTimeGreaterThan(Date value) {
            addCriterion("time >", value, "time");
            return (Criteria) this;
        }

        public Criteria andTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("time >=", value, "time");
            return (Criteria) this;
        }

        public Criteria andTimeLessThan(Date value) {
            addCriterion("time <", value, "time");
            return (Criteria) this;
        }

        public Criteria andTimeLessThanOrEqualTo(Date value) {
            addCriterion("time <=", value, "time");
            return (Criteria) this;
        }

        public Criteria andTimeIn(List<Date> values) {
            addCriterion("time in", values, "time");
            return (Criteria) this;
        }

        public Criteria andTimeNotIn(List<Date> values) {
            addCriterion("time not in", values, "time");
            return (Criteria) this;
        }

        public Criteria andTimeBetween(Date value1, Date value2) {
            addCriterion("time between", value1, value2, "time");
            return (Criteria) this;
        }

        public Criteria andTimeNotBetween(Date value1, Date value2) {
            addCriterion("time not between", value1, value2, "time");
            return (Criteria) this;
        }

        public Criteria andIntempIsNull() {
            addCriterion("inTemp is null");
            return (Criteria) this;
        }

        public Criteria andIntempIsNotNull() {
            addCriterion("inTemp is not null");
            return (Criteria) this;
        }

        public Criteria andIntempEqualTo(BigDecimal value) {
            addCriterion("inTemp =", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempNotEqualTo(BigDecimal value) {
            addCriterion("inTemp <>", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempGreaterThan(BigDecimal value) {
            addCriterion("inTemp >", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("inTemp >=", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempLessThan(BigDecimal value) {
            addCriterion("inTemp <", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempLessThanOrEqualTo(BigDecimal value) {
            addCriterion("inTemp <=", value, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempIn(List<BigDecimal> values) {
            addCriterion("inTemp in", values, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempNotIn(List<BigDecimal> values) {
            addCriterion("inTemp not in", values, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("inTemp between", value1, value2, "intemp");
            return (Criteria) this;
        }

        public Criteria andIntempNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("inTemp not between", value1, value2, "intemp");
            return (Criteria) this;
        }

        public Criteria andInhIsNull() {
            addCriterion("inH is null");
            return (Criteria) this;
        }

        public Criteria andInhIsNotNull() {
            addCriterion("inH is not null");
            return (Criteria) this;
        }

        public Criteria andInhEqualTo(BigDecimal value) {
            addCriterion("inH =", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhNotEqualTo(BigDecimal value) {
            addCriterion("inH <>", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhGreaterThan(BigDecimal value) {
            addCriterion("inH >", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("inH >=", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhLessThan(BigDecimal value) {
            addCriterion("inH <", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhLessThanOrEqualTo(BigDecimal value) {
            addCriterion("inH <=", value, "inh");
            return (Criteria) this;
        }

        public Criteria andInhIn(List<BigDecimal> values) {
            addCriterion("inH in", values, "inh");
            return (Criteria) this;
        }

        public Criteria andInhNotIn(List<BigDecimal> values) {
            addCriterion("inH not in", values, "inh");
            return (Criteria) this;
        }

        public Criteria andInhBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("inH between", value1, value2, "inh");
            return (Criteria) this;
        }

        public Criteria andInhNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("inH not between", value1, value2, "inh");
            return (Criteria) this;
        }

        public Criteria andOuttempIsNull() {
            addCriterion("outTemp is null");
            return (Criteria) this;
        }

        public Criteria andOuttempIsNotNull() {
            addCriterion("outTemp is not null");
            return (Criteria) this;
        }

        public Criteria andOuttempEqualTo(BigDecimal value) {
            addCriterion("outTemp =", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempNotEqualTo(BigDecimal value) {
            addCriterion("outTemp <>", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempGreaterThan(BigDecimal value) {
            addCriterion("outTemp >", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("outTemp >=", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempLessThan(BigDecimal value) {
            addCriterion("outTemp <", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempLessThanOrEqualTo(BigDecimal value) {
            addCriterion("outTemp <=", value, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempIn(List<BigDecimal> values) {
            addCriterion("outTemp in", values, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempNotIn(List<BigDecimal> values) {
            addCriterion("outTemp not in", values, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outTemp between", value1, value2, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuttempNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outTemp not between", value1, value2, "outtemp");
            return (Criteria) this;
        }

        public Criteria andOuthIsNull() {
            addCriterion("outH is null");
            return (Criteria) this;
        }

        public Criteria andOuthIsNotNull() {
            addCriterion("outH is not null");
            return (Criteria) this;
        }

        public Criteria andOuthEqualTo(BigDecimal value) {
            addCriterion("outH =", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthNotEqualTo(BigDecimal value) {
            addCriterion("outH <>", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthGreaterThan(BigDecimal value) {
            addCriterion("outH >", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("outH >=", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthLessThan(BigDecimal value) {
            addCriterion("outH <", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthLessThanOrEqualTo(BigDecimal value) {
            addCriterion("outH <=", value, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthIn(List<BigDecimal> values) {
            addCriterion("outH in", values, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthNotIn(List<BigDecimal> values) {
            addCriterion("outH not in", values, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outH between", value1, value2, "outh");
            return (Criteria) this;
        }

        public Criteria andOuthNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("outH not between", value1, value2, "outh");
            return (Criteria) this;
        }

        public Criteria andMaxIsNull() {
            addCriterion("max is null");
            return (Criteria) this;
        }

        public Criteria andMaxIsNotNull() {
            addCriterion("max is not null");
            return (Criteria) this;
        }

        public Criteria andMaxEqualTo(BigDecimal value) {
            addCriterion("max =", value, "max");
            return (Criteria) this;
        }

        public Criteria andMaxNotEqualTo(BigDecimal value) {
            addCriterion("max <>", value, "max");
            return (Criteria) this;
        }

        public Criteria andMaxGreaterThan(BigDecimal value) {
            addCriterion("max >", value, "max");
            return (Criteria) this;
        }

        public Criteria andMaxGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("max >=", value, "max");
            return (Criteria) this;
        }

        public Criteria andMaxLessThan(BigDecimal value) {
            addCriterion("max <", value, "max");
            return (Criteria) this;
        }

        public Criteria andMaxLessThanOrEqualTo(BigDecimal value) {
            addCriterion("max <=", value, "max");
            return (Criteria) this;
        }

        public Criteria andMaxIn(List<BigDecimal> values) {
            addCriterion("max in", values, "max");
            return (Criteria) this;
        }

        public Criteria andMaxNotIn(List<BigDecimal> values) {
            addCriterion("max not in", values, "max");
            return (Criteria) this;
        }

        public Criteria andMaxBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("max between", value1, value2, "max");
            return (Criteria) this;
        }

        public Criteria andMaxNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("max not between", value1, value2, "max");
            return (Criteria) this;
        }

        public Criteria andMinIsNull() {
            addCriterion("min is null");
            return (Criteria) this;
        }

        public Criteria andMinIsNotNull() {
            addCriterion("min is not null");
            return (Criteria) this;
        }

        public Criteria andMinEqualTo(BigDecimal value) {
            addCriterion("min =", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinNotEqualTo(BigDecimal value) {
            addCriterion("min <>", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinGreaterThan(BigDecimal value) {
            addCriterion("min >", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("min >=", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinLessThan(BigDecimal value) {
            addCriterion("min <", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinLessThanOrEqualTo(BigDecimal value) {
            addCriterion("min <=", value, "min");
            return (Criteria) this;
        }

        public Criteria andMinIn(List<BigDecimal> values) {
            addCriterion("min in", values, "min");
            return (Criteria) this;
        }

        public Criteria andMinNotIn(List<BigDecimal> values) {
            addCriterion("min not in", values, "min");
            return (Criteria) this;
        }

        public Criteria andMinBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("min between", value1, value2, "min");
            return (Criteria) this;
        }

        public Criteria andMinNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("min not between", value1, value2, "min");
            return (Criteria) this;
        }

        public Criteria andAvgIsNull() {
            addCriterion("avg is null");
            return (Criteria) this;
        }

        public Criteria andAvgIsNotNull() {
            addCriterion("avg is not null");
            return (Criteria) this;
        }

        public Criteria andAvgEqualTo(BigDecimal value) {
            addCriterion("avg =", value, "avg");
            return (Criteria) this;
        }

        public Criteria andAvgNotEqualTo(BigDecimal value) {
            addCriterion("avg <>", value, "avg");
            return (Criteria) this;
        }

        public Criteria andAvgGreaterThan(BigDecimal value) {
            addCriterion("avg >", value, "avg");
            return (Criteria) this;
        }

        public Criteria andAvgGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("avg >=", value, "avg");
            return (Criteria) this;
        }

        public Criteria andAvgLessThan(BigDecimal value) {
            addCriterion("avg <", value, "avg");
            return (Criteria) this;
        }

        public Criteria andAvgLessThanOrEqualTo(BigDecimal value) {
            addCriterion("avg <=", value, "avg");
            return (Criteria) this;
        }

        public Criteria andAvgIn(List<BigDecimal> values) {
            addCriterion("avg in", values, "avg");
            return (Criteria) this;
        }

        public Criteria andAvgNotIn(List<BigDecimal> values) {
            addCriterion("avg not in", values, "avg");
            return (Criteria) this;
        }

        public Criteria andAvgBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("avg between", value1, value2, "avg");
            return (Criteria) this;
        }

        public Criteria andAvgNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("avg not between", value1, value2, "avg");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNull() {
            addCriterion("updatetime is null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIsNotNull() {
            addCriterion("updatetime is not null");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeEqualTo(Date value) {
            addCriterion("updatetime =", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotEqualTo(Date value) {
            addCriterion("updatetime <>", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThan(Date value) {
            addCriterion("updatetime >", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeGreaterThanOrEqualTo(Date value) {
            addCriterion("updatetime >=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThan(Date value) {
            addCriterion("updatetime <", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeLessThanOrEqualTo(Date value) {
            addCriterion("updatetime <=", value, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeIn(List<Date> values) {
            addCriterion("updatetime in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotIn(List<Date> values) {
            addCriterion("updatetime not in", values, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeBetween(Date value1, Date value2) {
            addCriterion("updatetime between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andUpdatetimeNotBetween(Date value1, Date value2) {
            addCriterion("updatetime not between", value1, value2, "updatetime");
            return (Criteria) this;
        }

        public Criteria andIlqYqIsNull() {
            addCriterion("iLq_yq is null");
            return (Criteria) this;
        }

        public Criteria andIlqYqIsNotNull() {
            addCriterion("iLq_yq is not null");
            return (Criteria) this;
        }

        public Criteria andIlqYqEqualTo(String value) {
            addCriterion("iLq_yq =", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqNotEqualTo(String value) {
            addCriterion("iLq_yq <>", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqGreaterThan(String value) {
            addCriterion("iLq_yq >", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqGreaterThanOrEqualTo(String value) {
            addCriterion("iLq_yq >=", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqLessThan(String value) {
            addCriterion("iLq_yq <", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqLessThanOrEqualTo(String value) {
            addCriterion("iLq_yq <=", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqLike(String value) {
            addCriterion("iLq_yq like", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqNotLike(String value) {
            addCriterion("iLq_yq not like", value, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqIn(List<String> values) {
            addCriterion("iLq_yq in", values, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqNotIn(List<String> values) {
            addCriterion("iLq_yq not in", values, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqBetween(String value1, String value2) {
            addCriterion("iLq_yq between", value1, value2, "ilqYq");
            return (Criteria) this;
        }

        public Criteria andIlqYqNotBetween(String value1, String value2) {
            addCriterion("iLq_yq not between", value1, value2, "ilqYq");
            return (Criteria) this;
        }
    }

    /**
     * t_testdata
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_testdata 2019-07-23
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}